local L = AceLibrary("AceLocale-2.2"):new("TrainerFu-MapNotes")

local gratuity = AceLibrary("Gratuity-2.0")
local Tablet = AceLibrary("Tablet-2.0")

L:RegisterTranslations("enUS", function() return {
	["Enable trainer mapnotes"] = true,
	["Add a mapnote to show where your trainers are. You need Cartograpther installed."] = true,

	["Alchemist"] = true,
	["Blacksmith"] = true,
	["Poison"] = true,
	["Cooking"] = true,
	["Misc"] = true,
	["Demon"] = true,
	["Druid"] = true,
	["Enchanter"] = true,
	["Engineer"] = true,
	["First Aid"] = true,
	["Fishing"] = true,
	["Herbalism"] = true,
	["Hunter"] = true,
	["Jewelcrafter"] = true,
	["Leatherworking"] = true,
	["Mage"] = true,
	["Mining"] = true,
	["Paladin"] = true,
	["Pet"] = true,
	["Priest"] = true,
	["Rogue"] = true,
	["Shaman"] = true,
	["Skinning"] = true,
	["Tailor"] = true,
	["Warlock"] = true,
	["Warrior"] = true,
} end)

TrainerFu_TrainerNotes = TrainerFu:NewModule("MapNotes", "AceEvent-2.0", "AceConsole-2.0")

TrainerFu_TrainerNotes.icon = {
	["Alchemist"] = {
        text = L["Alchemist"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Alchemy",
    },
    ["Blacksmith"] = {
        text = L["Blacksmith"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Blacksmithing",
    },
	["Poison"] = {
        text = L["Poison"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Poison",
    },
	["Cooking"] = {
        text = L["Cooking"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Cooking",
    },
    ["Misc"] = {
        text = L["Misc"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Misc",
    },
    ["Demon"] = {
        text = L["Demon"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Demon",
    },
	["Druid"] = {
        text = L["Druid"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Druid",
    },
	["Enchanter"] = {
        text = L["Enchanter"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Enchanting",
    },
	["Engineer"] = {
        text = L["Engineer"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Engineering",
    },
	["First Aid"] = {
        text = L["First Aid"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Firstaid",
    },
	["Fishing"] = {
        text = L["Fishing"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Fishing",
    },
	["Herbalism"] = {
        text = L["Herbalism"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Herbalism",
    },
	["Hunter"] = {
        text = L["Hunter"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Hunter",
    },
	["Jewelcrafter"] = {
        text = L["Jewelcrafter"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Jewelcrafting",
    },
	["Leatherworking"] = {
        text = L["Leatherworking"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Leatherworking",
    },
	["Mage"] = {
        text = L["Mage"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Mage",
    },
	["Mining"] = {
        text = L["Mining"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Mining",
    },
	["Paladin"] = {
        text = L["Paladin"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Paladin",
    },
	["Pet"] = {
        text = L["Pet"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Pet",
    },
	["Priest"] = {
        text = L["Priest"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Priest",
    },
	["Rogue"] = {
        text = L["Rogue"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Rogue",
    },
	["Shaman"] = {
        text = L["Shaman"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Shaman",
    },
	["Skinning"] = {
        text = L["Skinning"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Skinning",
    },
	["Tailor"] = {
        text = L["Tailor"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Tailoring",
    },
	["Warlock"] = {
        text = L["Warlock"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Warlock",
    },
	["Warrior"] = {
        text = L["Warrior"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Warrior",
    },
}

function TrainerFu_TrainerNotes:OnInitialize()
	self.db = TrainerFu:AcquireDBNamespace("MapNotes")
    TrainerFu:RegisterDefaults("MapNotes", "account", {
		TrainerNotes = {}
    })
	
	TrainerFu.OnMenuRequest.args.MapNotes = {
		type = 'group',
		name = "MapNotes",
		desc = "MapNote options",
		args = {
			addmapnote = {
				type = 'toggle',
				name = L["Enable trainer mapnotes"],
				desc = L["Add a mapnote to show where your trainers are. You need Cartograpther installed."],
				get = function() return TrainerFu:IsModuleActive(self) end,
				set = function() TrainerFu:ToggleModuleActive(self) end,
				disabled = function() return not Cartographer_Notes end
			}
		}
	}
end

function TrainerFu_TrainerNotes:OnEnable()
	if Cartographer_Notes then
        if not self.iconsregistered then
			for k,v in pairs(self.icon) do
                Cartographer_Notes:RegisterIcon(k, v)
            end
            self.iconsregistered = true
        end

        Cartographer_Notes:RegisterNotesDatabase('TrainerFu', self.db.account.TrainerNotes, self)
		self:RegisterEvent("TrainerFu_VisitingTrainer", "AddTrainerMapNote")
    else
        TrainerFu:ToggleModuleActive(self, false)
    end
end

function TrainerFu_TrainerNotes:OnDisable()
    self:UnregisterAllEvents()

    if Cartographer_Notes then
        Cartographer_Notes:UnregisterNotesDatabase('TrainerFu')
    end
end

function TrainerFu_TrainerNotes:AddTrainerMapNote(trainer)
	--Class trainer
	local _,_,iconName = string.find(trainer.type, "([%a%s]+)%sTrainer")
	--Profession trainer
	if not iconName then
		_,_,iconName = string.find(trainer.type, "[%a%s]+%s([%a%s]+)")
	end
	--If there is no icon for trainer
	if not IconName or not L:HasTranslation(iconName) then 
		iconName = "Misc"
	end
	
	Cartographer_Notes:SetNote(
		trainer.location, trainer.xcoord, trainer.ycoord, L:GetReverseTranslation(iconName), "TrainerFu",
		'title',  trainer.type,
		'titleR', 0,
		'titleG', 1,
		'titleB', 0,
		'info', trainer.name,
		'infoR', 1,
		'infoG', 1,
		'infoB', 1
	)
end
